unit UDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  U3DCnvs, ExtCtrls, ComCtrls, Buttons, StdCtrls, Math;

type
  TF3D_Demo = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Panel8: TPanel;
    BitBtn2: TBitBtn;
    Panelyz: TPanel;
    Panel3: TPanel;
    Panelxy: TPanel;
    Panel5: TPanel;
    Panelzx: TPanel;
    Panel7: TPanel;
    Panel3DView: TPanel;
    Panel10: TPanel;
    Panel21: TPanel;
    TrackBar1: TTrackBar;
    Panel22: TPanel;
    TrackBar2: TTrackBar;
    Panel6: TPanel;
    C3DCanvas1: TC3DCanvas;
    Panel2: TPanel;
    TrackBar3: TTrackBar;
    Panel4: TPanel;
    TrackBar4: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
  private
    { Private declarations }
    ProjectionCanvas:array[1..4] of TC3DCanvas;
    procedure Draw3DObject(C3DCanvas:TC3DCanvas);
    function  Peaks(x,y:extended):extended;
    procedure DrawPeaks(C3DCanvas:TC3DCanvas);
    procedure ShowDemo;
  public
    { Public declarations }
  end;

var
  F3D_Demo: TF3D_Demo;
  Pts:array[-15..15,-15..15] of TPoint3D;
  
implementation

{$R *.DFM}

procedure TF3D_Demo.FormCreate(Sender: TObject);
var i,j :integer;
begin
  //yz plane
  ProjectionCanvas[1]:=TC3DCanvas.Create(Self);
  ProjectionCanvas[1].Parent:=Panelyz;
  ProjectionCanvas[1].Align:=alClient;
  ProjectionCanvas[1].Viewer.Latitude:=0;
  ProjectionCanvas[1].Viewer.Longitude:=0;
  //xy plane
  ProjectionCanvas[2]:=TC3DCanvas.Create(Self);
  ProjectionCanvas[2].Parent:=Panelxy;
  ProjectionCanvas[2].Align:=alClient;
  ProjectionCanvas[2].Viewer.Latitude:=90;
  ProjectionCanvas[2].Viewer.Longitude:=0;
  //zx plane
  ProjectionCanvas[3]:=TC3DCanvas.Create(Self);
  ProjectionCanvas[3].Parent:=Panelzx;
  ProjectionCanvas[3].Align:=alClient;
  ProjectionCanvas[3].Viewer.Latitude:=0;
  ProjectionCanvas[3].Viewer.Longitude:=90;
  // 3D View
  ProjectionCanvas[4]:=TC3DCanvas.Create(Self);
  ProjectionCanvas[4].Parent:=Panel3DView;
  ProjectionCanvas[4].Align:=alClient;
  ProjectionCanvas[4].Viewer.Latitude:=30;
  ProjectionCanvas[4].Viewer.Longitude:=30;

  TrackBar1.Position:=Trunc(ProjectionCanvas[4].Viewer.Longitude);
  TrackBar2.Position:=Trunc(ProjectionCanvas[4].Viewer.Latitude);

  TrackBar3.Position:=Trunc(C3DCanvas1.Viewer.Longitude);
  TrackBar4.Position:=Trunc(C3DCanvas1.Viewer.Latitude);

  // calculate peaks to be drawn
  for i:=-15 to 15 do
    for j:=-15 to 15 do
      Pts[i,j]:=Point3D(i/5,j/5,0.4*Peaks(i/5,j/5));

end;

procedure TF3D_Demo.Draw3DObject(C3DCanvas:TC3DCanvas);
var Pts_1:array[1..6] of TPoint3D;
    Pts_2:array[1..6] of TPoint3D;
    i:byte;
    P1,P2:TPoint3D;
begin
  Pts_1[1]:=Point3D(0, 0   , 0   );
  Pts_1[2]:=Point3D(0, 100 , 0   );
  Pts_1[3]:=Point3D(0, 100 , 30.7);
  Pts_1[4]:=Point3D(0, 45.5, 30.7);
  Pts_1[5]:=Point3D(0, 45.5, 50.8);
  Pts_1[6]:=Point3D(0, 0   , 50.8);

  for i:=1 to 6 do begin
    Pts_2[i]:=Pts_1[i];
    Pts_2[i].x:=Pts_1[i].x + 60.0;
  end;

  P1:=Point3D(70,10,-10);
  P2:=Point3D(70,100,-10);
  with C3DCanvas do begin
    Clear;
    Brush.Style:=bsClear;
    for i:=1 to 6 do begin
      MoveTo(Pts_1[i]);
      LineTo(Pts_2[i]);
    end;
    Polygon(Pts_1);
    Polygon(Pts_2);
    TextOut(P1,P2,'3D Canvas Demo');
  end;
end;

procedure TF3D_Demo.TrackBar1Change(Sender: TObject);
begin
  ProjectionCanvas[4].Viewer.Longitude:=TrackBar1.Position;
  Draw3DObject(ProjectionCanvas[4]);
end;

procedure TF3D_Demo.TrackBar2Change(Sender: TObject);
begin
  ProjectionCanvas[4].Viewer.Latitude:=TrackBar2.Position;
  Draw3DObject(ProjectionCanvas[4]);
end;

procedure TF3D_Demo.FormPaint(Sender: TObject);
begin
  ShowDemo;
end;

procedure TF3D_Demo.FormShow(Sender: TObject);
begin
  ShowDemo;
end;

procedure TF3D_Demo.FormActivate(Sender: TObject);
begin
  ShowDemo;
end;

procedure TF3D_Demo.FormResize(Sender: TObject);
begin
  ShowDemo;
end;

procedure TF3D_Demo.PageControl1Change(Sender: TObject);
begin
  ShowDemo;
end;

function  TF3D_Demo.Peaks(x,y:extended):extended;
begin
  Result:=  3*sqr(1-x)*exp(-sqr(x)-Sqr(y+1))
            -10*(x/5 - power(x,3)-power(y,5))*exp(-sqr(x)-sqr(y))
            -(1/3)*exp(-sqr(x+1)-sqr(y));
end;

procedure TF3D_Demo.DrawPeaks(C3DCanvas:TC3DCanvas);
var i,j:integer;
begin
  with C3DCanvas do begin
    Clear;
    for i:=-15 to 15 do begin
      MoveTo(Pts[i,-15]);
      for j:=-14 to 15 do
        LineTo(Pts[i,j]);
    end;

    for j:=-15 to 15 do begin
      MoveTo(Pts[-15,j]);
      for i:=-15 to 15 do
        LineTo(Pts[i,j]);
    end;
  end;
end;

procedure TF3D_Demo.TrackBar3Change(Sender: TObject);
begin
  C3DCanvas1.Viewer.Latitude:=TrackBar3.Position;
  DrawPeaks(C3DCanvas1);
end;

procedure TF3D_Demo.TrackBar4Change(Sender: TObject);
begin
  C3DCanvas1.Viewer.Longitude:=TrackBar4.Position;
  DrawPeaks(C3DCanvas1);
end;

procedure TF3D_Demo.ShowDemo;
var i:byte;
begin
  if PageControl1.ActivePage =  TabSheet1 then begin
    for i:=1 to 4 do Draw3DObject(ProjectionCanvas[i]);
  end;

  if PageControl1.ActivePage =  TabSheet2 then begin
    DrawPeaks(C3DCanvas1);
  end;
end;

end.
